local gt = this.getroottable();

if (!("Items" in gt.Const))
{
	gt.Const.Items <- {};
}

gt.Const.Items.Default <- {
	PlayerQuiver = "bust_quiver_01",
	PlayerNakedBody = "bust_naked_body_01",
	PlayerCorpse = "bust_naked_body_01_dead",
	ShieldDecal = "broken_shield_01",
	GenericItemName = "Generic Item",
	GenericItemIcon = "skills/passive_03.png",
	RaiseShieldOffset = this.createVec(0, 10),
	RaiseShieldDuration = 0.15,
	LowerShieldDuration = 0.4,
	RaiseWeaponDuration = 0.25,
	LowerWeaponDuration = 0.2
};
gt.Const.Items.ItemType <- {
	None = 0,
	Legendary = 1 << 0,
	Named = 1 << 1,
	Armor = 1 << 2,
	Helmet = 1 << 3,
	Shield = 1 << 4,
	Defensive = 1 << 5,
	Weapon = 1 << 6,
	OneHanded = 1 << 7,
	TwoHanded = 1 << 8,
	MeleeWeapon = 1 << 9,
	RangedWeapon = 1 << 10,
	Ammo = 1 << 11,
	Tool = 1 << 12,
	Accessory = 1 << 13,
	Usable = 1 << 14,
	Misc = 1 << 15,
	Loot = 1 << 16,
	Crafting = 1 << 17,
	Supply = 1 << 18,
	Food = 1 << 19,
	TradeGood = 1 << 20,
	Bag = 1 << 21,
};
gt.Const.Items.ItemFilter <- {
	Weapons = this.Const.Items.ItemType.Weapon | this.Const.Items.ItemType.Accessory | this.Const.Items.ItemType.Tool | this.Const.Items.ItemType.Ammo,
	Armor = this.Const.Items.ItemType.Armor | this.Const.Items.ItemType.Helmet | this.Const.Items.ItemType.Shield,
	Misc = this.Const.Items.ItemType.Supply | this.Const.Items.ItemType.Food | this.Const.Items.ItemType.Misc | this.Const.Items.ItemType.TradeGood | this.Const.Items.ItemType.Loot | this.Const.Items.ItemType.Crafting | this.Const.Items.ItemType.Bag,
	Usable = this.Const.Items.ItemType.Usable,
	All = (1 << 22) - 1 
};
gt.Const.Items.AmmoType <- {
	None = 0,
	Arrows = 1,
	Bolts = 2,
	Spears = 4
};
gt.Const.Items.Property <- {
	None = 0,
	IgnoresShieldwall = 8
};
gt.Const.Items.InventoryEventType <- {
	None = 0,
	Equipped = 1,
	PlacedInBag = 2,
	PlacedInStash = 3,
	PlacedOnGround = 4
};
gt.Const.Items.Paint <- {
	Black = 0,
	WhiteBlue = 1,
	WhiteGreenYellow = 2,
	OrangeRed = 3,
	Red = 4
};
gt.Const.Items.ConditionColor <- [
	"#ff1e00",
	"#ff8400",
	"#ffea00",
	"#c0ff00",
	"#ffffff"
];
