this.bull_potion_secret_event <- this.inherit("scripts/events/event", {
	m = {
		Worker = null,
		Injuried = null,
	},
	function create()
	{
		this.m.ID = "event.bull_potion_secret";
		this.m.Title = "During camp...";
		this.m.Cooldown = 1.0 * this.World.getTime().SecondsPerDay;
		this.m.Screens.push({
			ID = "A",
			Text = "[img]gfx/ui/events/event_26.png[/img]{%worker% sits about the campfire neear you. He stares on fire for few minutes, than says%SPEECH_ON%Look at %injuried%. His injury makes him upset and crazy, I now what it is. When I was working for %randomname%, he suffered from collapsed lung. But he told us, small hole in lung is not big problem, but he always was afraid to take a deep breath. So, he finally had bought a dozen of bottles with strange liquid - it reduced his pain and he could work with us as before. Not exactly, but anyway. He told that he had paid a lot to get a secret of this miracle potion and of course one day after few mugs of beer he cough it up.%SPEECH_OFF%}",
			Image = "",
			List = [],
			Characters = [],
			Options = [
				{
					Text = "It is really useful knowledge.",
					function getResult( _event )
					{
						return 0;
					}

				}
			],
			function start( _event )
			{
				this.Characters.push(_event.m.Worker.getImagePath());

				local item = this.new("scripts/items/misc/bull_potion_item");
				this.List.push({
					id = 10,
					icon = "ui/items/" + item.getIcon(),
					text = "You get recipe of " + item.getName()
				});

				this.World.Tags.set("BullPotionSecret", true);
			}
		});
	}

	function onUpdateScore()
	{
		if (this.World.Tags.get("BullPotionSecret") == true)
		{
			return;
		}

		local brothers = this.World.getPlayerRoster().getAll();
		local candidatesWorker = [];
		local candidatesInjuried = [];

		foreach( bro in brothers )
		{
			if (bro.getBackground().getID() == "background.daytaler" ||
				bro.getBackground().getID() == "background.miner" ||
				bro.getBackground().getID() == "background.mason" ||
				bro.getBackground().getID() == "background.lumberjack")
			{
				candidatesWorker.push(bro);
			}

			if (bro.getSkills().hasSkill("injury.broken_elbow_joint") ||
				bro.getSkills().hasSkill("injury.broken_knee") ||
				bro.getSkills().hasSkill("injury.collapsed_lung_part") ||
				bro.getSkills().hasSkill("injury.maimed_foot") ||
				bro.getSkills().hasSkill("injury.weakened_heart"))
			{
				candidatesInjuried.push(bro);
			}
		}

		if (candidatesWorker.len() * candidatesInjuried.len() == 0)
		{
			return;
		}

		this.m.Worker = candidatesWorker[this.Math.rand(0, candidatesWorker.len() - 1)];
		this.m.Injuried = candidatesInjuried[this.Math.rand(0, candidatesInjuried.len() - 1)];
		this.m.Score = 25 * (candidatesWorker.len() + candidatesInjuried.len());
	}

	function onPrepare()
	{
	}

	function onPrepareVariables( _vars )
	{
		_vars.push([
			"worker",
			this.m.Worker.getNameOnly()
		]);
		_vars.push([
			"injuried",
			this.m.Injuried.getNameOnly()
		]);
	}

	function onClear()
	{
		this.m.Worker = null;
		this.m.Injuried = null;
	}
});
