this.bull_potion_effect <- this.inherit("scripts/skills/injury/injury", {
	m = {},
	function create()
	{
		this.injury.create();
		this.m.ID = "effects.bull_potion";
		this.m.Name = "Bull potion";
		this.m.Description = "This character drunk bull potion - his permanent injuries do less pain.";
		this.m.Icon = "skills/status_effect_06.png";
		this.m.Type = this.m.Type | this.Const.SkillType.StatusEffect | this.Const.SkillType.DrugEffect;
		this.m.IsHealingMentioned = false;
		this.m.IsTreatable = false;
		this.m.IsContentWithReserve = false;
		this.m.HealingTimeMin = 2;
		this.m.HealingTimeMax = 4;
	}

	function getTooltip()
	{
		local ret = [
			{
				id = 1,
				type = "title",
				text = this.getName()
			},
			{
				id = 2,
				type = "description",
				text = this.getDescription()
			},
			{
				id = 13,
				icon = "ui/icons/days_wounded.png"
				type = "text",
				text = "Reduce penalty from permanent injuries"
			},
			{
				id = 13,
				type = "text",
				text = "Effect only Broken Elbow Joint, Broken Knee, Partly Collapsed Lung, Maimed Foot or Weakened Heart"
			}
		];
		this.addTooltipHint(ret);
		return ret;
	}

	function onSerialize( _out )
	{
		this.injury.onSerialize(_out);
		_out.writeU8(this.m.HealingTimeMin);
		_out.writeU8(this.m.HealingTimeMax);
		_out.writeF32(this.m.XPGainMult);
	}

	function onDeserialize( _in )
	{
		this.injury.onDeserialize(_in);
		this.m.HealingTimeMin = _in.readU8();
		this.m.HealingTimeMax = _in.readU8();
		this.m.XPGainMult = _in.readF32();
	}
});