this.broken_knee_injury <- this.inherit("scripts/skills/injury_permanent/permanent_injury", {
	m = {
		Painless = false
	},
	function create()
	{
		this.permanent_injury.create();
		this.m.ID = "injury.broken_knee";
		this.m.Name = "Broken Knee";
		this.m.Description = "This character took something to the knee, and it never fully healed. Lunging forward or dodging can be painful, and it lacks any grace.";
		this.m.Icon = "ui/injury/injury_permanent_icon_11.png";
	}

	function getTooltip()
	{
		local ret = [
			{
				id = 1,
				type = "title",
				text = this.getName()
			},
			{
				id = 2,
				type = "description",
				text = this.getDescription()
			},
			{
				id = 7,
				type = "text",
				icon = "ui/icons/melee_defense.png",
				text = "[color=" + this.Const.UI.Color.NegativeValue + "]-" + (this.m.Painless ? 20 : 40) + "%[/color] Melee Defense"
			},
			{
				id = 7,
				type = "text",
				icon = "ui/icons/ranged_defense.png",
				text = "[color=" + this.Const.UI.Color.NegativeValue + "]-" + (this.m.Painless ? 20 : 40) + "%[/color] Ranged Defense"
			},
			{
				id = 7,
				type = "text",
				icon = "ui/icons/initiative.png",
				text = "[color=" + this.Const.UI.Color.NegativeValue + "]-" + (this.m.Painless ? 20 : 40) + "%[/color] Initiative"
			},
			{
				id = 16,
				type = "text",
				icon = "ui/icons/special.png",
				text = "Is always content with being in reserve"
			}
		];
		this.addTooltipHint(ret);
		return ret;
	}

	function onUpdate( _properties )
	{
		this.m.Painless = this.getContainer().getActor().getSkills().hasSkill("effects.bull_potion");

		_properties.MeleeDefenseMult *= this.m.Painless ? 0.8 : 0.6;
		_properties.RangedDefenseMult *= this.m.Painless ? 0.8 : 0.6;
		_properties.InitiativeMult *= this.m.Painless ? 0.8 : 0.6;
		_properties.IsContentWithBeingInReserve = true;
	}

	function onApplyAppearance()
	{
	}

});
